seo:
  title: 'Agile for developers: Refactoring code'
  description: >-
    The time commitment involved in refactoring may cause hesitation, but the
    impact on developer productivity and efficiency outweighs the initial
    discomfort.
  ogTitle: 'Agile for developers: Refactoring code'
  ogDescription: >-
    The time commitment involved in refactoring may cause hesitation, but the
    impact on developer productivity and efficiency outweighs the initial
    discomfort.
  noIndex: false
  ogImage: images/blog/hero-images/refactorpost.jpg
  ogUrl: https://about.gitlab.com/blog/agile-for-developers-refactor-code
  ogSiteName: https://about.gitlab.com
  ogType: article
  canonicalUrls: https://about.gitlab.com/blog/agile-for-developers-refactor-code
  schema: |2-

                            {
            "@context": "https://schema.org",
            "@type": "Article",
            "headline": "Agile for developers: Refactoring code",
            "author": [{"@type":"Person","name":"Suri Patel"}],
            "datePublished": "2019-12-18",
          }

content:
  title: 'Agile for developers: Refactoring code'
  description: >-
    The time commitment involved in refactoring may cause hesitation, but the
    impact on developer productivity and efficiency outweighs the initial
    discomfort.
  authors:
    - Suri Patel
  heroImage: images/blog/hero-images/refactorpost.jpg
  date: '2019-12-18'
  body: >


    It’s difficult to cook in a cluttered, untidy kitchen. You need a specific
    knife, but it needs to be washed. You need that one mixing bowl, but it’s
    not in the cabinet where you usually keep it. You can’t find a place for the
    cutting board, because the countertop has no room. Software development is
    similar to cooking - you need a tidy codebase to deliver rapidly. If you
    don’t clean your code as you develop, you can find yourself surrounded by a
    mess. Fortunately, refactoring code helps you keep your [source
    code](/stages-devops-lifecycle/source-code-management/) neat and tidy.


    ## Refactor code to accelerate Agile delivery


    Refactoring simplifies the design of code, without altering its behavior, to
    increase maintainability and readability. Teams refactor code before adding
    updates or releasing features in an effort to improve code quality so that
    future iterations built on original code are not bogged down by confusion
    and clutter. As such, this process helps to [accelerate Agile
    delivery](/solutions/agile-delivery/).


    >  “None of my inventions came by accident. I see a worthwhile need to be
    met and I make trial after trial until it comes.” — Thomas Edison


    Refactoring isn’t a random exercise in which developers tinker with code.
    It’s a precise process designed to enhance the internal structure of a
    program’s source code. While it may seem like a tedious task, refactoring
    has long-term business value.  


    ## How to get started with refactoring


    Staring at unrefactored code trying to determine where to start can be a
    frightening experience. Fortunately, there are a few methods you can use to
    make refactoring a little easier. 


    ### Incremental refactoring


    The simplest way to get started is to make small improvements. Make a list
    of the parts of your system that change most often and refactor those areas.
    Making incremental improvements on the files that your team works with most
    often can help you steadily work through your code. By targeting the areas
    that are used most often, refactoring can have a significant impact on your
    overall system.


    ### Test-driven development


    You can think of test-driven development as cleaning as you’re coding. If
    you’d like to revolutionize the way your team develops and make refactoring
    an integrated aspect of your workflow, you can embrace test-driven
    development, which incorporates coding, unit tests, and refactoring to
    program in short development cycles. Developers write a failing automated
    test to define a new function before writing the smallest amount of code to
    pass the test. The code is then refactored to an ideal state.


    ## The benefits of refactoring code


    Refactoring prevents code rot, such as bad dependencies between classes,
    myriad patches, incorrect allocation of class responsibilities, and
    duplicate code, resulting in a more efficient code base. The time taken to
    refactor pays dividends, since it’s easier to clean code closer to when it
    was written rather than rush to fix problems later.


    The time commitment involved in refactoring may cause hesitation, but the
    impact on developer productivity and efficiency outweighs the initial
    discomfort. When developers take the time to refactor, they continually
    maintain a tidy source code so that other developers can easily deliver
    without running into problems. Refactoring helps create a culture of shared
    responsibility, trust, and collaboration.


    With refactoring, the QA and debugging stages are simpler, since there is
    more cohesion to the overall code. Furthermore, software assets can be
    extended for years, allowing users to experience prolonged value rather than
    dealing with an unusable system. 


    ## What’s next for your team?


    Agile techniques have the power to transform your team’s culture, sparking
    seamless delivery, innovation, and collaboration. Depending on your team’s
    challenges, there’s a technique to help your team through it. With [pairing
    sessions](/blog/2019/08/20/agile-pairing-sessions/), your developers can
    bridge knowledge gaps, increase communication, and develop solutions to
    challenging problems. By [strengthening group
    development](/blog/2019/12/13/how-to-strengthen-agile-teams-with-tuckmans-model/),
    you can help your team rebuild after breaking down silos. When your team
    [embraces an Agile mindset](/blog/2019/06/13/agile-mindset/), they’re more
    flexible and can easily adapt to changes. Refactoring is one step in a
    journey to help your team cultivate a strong Agile culture. 


    Cover image by [Barn
    Images](https://unsplash.com/@barnimages?utm_source=unsplash&utm_medium=referral&utm_content=creditCopyText)
    on [Unsplash](https://unsplash.com/photos/t5YUoHW6zRo)

    {: .note}
  category: Company
  tags:
    - agile
    - collaboration
    - workflow
config:
  slug: agile-for-developers-refactor-code
  featured: false
  template: BlogPost
